function writeppm(fil,m,str)
//create an image file from the matrix m
//str is 'b' if m is binary (black and white image)
//str is 'g' for gray level
//str is 'p' for color
select str,
case 'b' then 
  niveau=1;head0='P1';
case 'g' then 
  niveau=255;head0='P2';
else 
  niveau=255;head0='P3';
end;

[x,y]=size(m);
if str=='p'&x/3<>int(x/3) then error('not a color matrix');end

if head0=='P3' then x=x/3;end;

ma=maxi(m);mi=mini(m);
a=niveau/(ma-mi);
b=-a*mi
m=a*m+b;
m=mini(niveau*ones(m),m);
m=maxi(zeros(m),m);

u=file('open',fil,'unknown')
write(u,[head0;
	 '# CREATOR: SCILAB-2.5'
         strcat(string([x y]),' ')],'(a)');
     
     
     
if head0~='P1' then write(u,string(niveau),'(a)');end
m=round(m(:)');
select str,
case 'b' then   k=int(x*y/35);
  m1=m(1:k*35);
  write(u,m1,'(35i2)');
  if k*35<x*y then
    m2=m(k*35+1:x*y);write(u,m2,'(35i2)');
  end
case 'g' then 
  write(u,m,'(17(f4.0,1x))')
else 
  write(u,m,'(15(f4.0,1x))')
end;
file('close',u)
endfunction





